variables:
  CONTAINER_IMAGE: registry.gitlab.com/$CI_PROJECT_PATH

stages:
  - build
  - deploy

build:
  stage: build
  image: docker:stable
  services:
    - docker:dind
  script:
    - echo $CONTAINER_IMAGE
    - echo $CI_BUILD_REF
    - docker image build -t $CONTAINER_IMAGE:$CI_BUILD_REF -t $CONTAINER_IMAGE:latest .
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
    - docker image push $CONTAINER_IMAGE:latest
    - docker image push $CONTAINER_IMAGE:$CI_BUILD_REF
  only:
  - prod

deploy-swarm:
  stage: deploy
  image: registry.gitlab.com/devs.cordeiro/portainer-cli:latest
  script:
    - env
    - envsubst < docker-compose.yml > .gitlab-prod.env
    - cat .gitlab-prod.env
    - echo ${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
    - portainer-cli dp $PORTAINER_ID $PORTAINER_SWARM ${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG} .gitlab-prod.env
  only:
  - prod

deploy-dev:
  stage: deploy
  image: registry.gitlab.com/devs.cordeiro/portainer-cli:latest
  script:
    - env
    - cat .gitlab-dev.yml
    - envsubst < .gitlab-dev.yml > .gitlab-dev.env
    - cat .gitlab-dev.env
    - portainer-cli dp $PORTAINER_ID $PORTAINER_SWARM ${GITLAB_USER_ID}-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG} .gitlab-dev.env
  only:
  - dev
